diff --git a/src/effects/RecursiveBlur.qml b/src/effects/RecursiveBlur.qml
index a90b179..458dc65 100644
--- a/src/effects/RecursiveBlur.qml
+++ b/src/effects/RecursiveBlur.qml
@@ -270,31 +270,9 @@ Item {
         anchors.fill: verticalBlur
         visible: !verticalBlur.visible
 
-        vertexShader: "
-            attribute highp vec4 qt_Vertex;
-            attribute highp vec2 qt_MultiTexCoord0;
-            uniform highp mat4 qt_Matrix;
-            uniform highp float expandX;
-            uniform highp float expandY;
-            varying highp vec2 qt_TexCoord0;
-
-            void main() {
-                mediump vec2 texCoord = qt_MultiTexCoord0;
-                texCoord.s = (texCoord.s - expandX) / (1.0 - 2.0 * expandX);
-                texCoord.t = (texCoord.t - expandY) / (1.0 - 2.0 * expandY);
-                qt_TexCoord0 = texCoord;
-                gl_Position = qt_Matrix * qt_Vertex;
-            }
-        "
-
-        fragmentShader: "
-            varying mediump vec2 qt_TexCoord0;
-            uniform highp float qt_Opacity;
-            uniform lowp sampler2D source;
-            void main() {
-                gl_FragColor = texture2D(source, qt_TexCoord0) * qt_Opacity;
-            }
-        "
+        vertexShader: "qrc:/qt-project.org/imports/QtGraphicalEffects/shaders/recursiveblur.vert"
+
+        fragmentShader: "qrc:/qt-project.org/imports/QtGraphicalEffects/shaders/recursiveblur.frag"
     }
 
     ShaderEffectSource {
diff --git a/src/effects/ThresholdMask.qml b/src/effects/ThresholdMask.qml
index 5136ffb..36e0365 100644
--- a/src/effects/ThresholdMask.qml
+++ b/src/effects/ThresholdMask.qml
@@ -210,18 +210,6 @@ Item {
 
         anchors.fill: parent
 
-        fragmentShader: "
-            varying highp vec2 qt_TexCoord0;
-            uniform highp float qt_Opacity;
-            uniform lowp sampler2D source;
-            uniform lowp sampler2D maskSource;
-            uniform highp float threshold;
-            uniform highp float spread;
-            void main(void) {
-                lowp vec4 colorFragment = texture2D(source, qt_TexCoord0.st);
-                lowp vec4 maskFragment = texture2D(maskSource, qt_TexCoord0.st);
-                gl_FragColor = colorFragment * smoothstep(threshold * (1.0 + spread) - spread, threshold * (1.0 + spread), maskFragment.a) * qt_Opacity;
-            }
-        "
+        fragmentShader: "qrc:/qt-project.org/imports/QtGraphicalEffects/shaders/thresholdmask.frag"
     }
 }
diff --git a/src/effects/ZoomBlur.qml b/src/effects/ZoomBlur.qml
index d3cbd14..32e7be5 100644
--- a/src/effects/ZoomBlur.qml
+++ b/src/effects/ZoomBlur.qml
@@ -37,7 +37,7 @@
 **
 ****************************************************************************/
 
-import QtQuick 2.0
+import QtQuick 2.8
 import QtGraphicalEffects.private 1.0
 
 /*!
@@ -275,7 +275,10 @@ Item {
         "
 
         function buildFragmentShader() {
-            var shader = fragmentShaderSkeleton
+            var shader = ""
+            if (GraphicsInfo.profile == GraphicsInfo.OpenGLCoreProfile)
+                shader += "#version 150 core\n#define varying in\n#define gl_FragColor fragColor\n#define texture2D texture\nout vec4 fragColor;\n"
+            shader += fragmentShaderSkeleton
             var expandSteps = ""
 
             if (transparentBorder) {
diff --git a/src/effects/effects_plugin.pro b/src/effects/effects_plugin.pro
index 7ae59a6..e889236 100644
--- a/src/effects/effects_plugin.pro
+++ b/src/effects/effects_plugin.pro
@@ -30,7 +30,10 @@ QML_FILES = \
     ThresholdMask.qml \
     ZoomBlur.qml \
 
-!static: CONFIG += qmlcache
+# !static: CONFIG += qmlcache
+
+RESOURCES += \
+    qtgraphicaleffectsshaders.qrc
 
 QMAKE_DOCS = $$PWD/doc/qtgraphicaleffects.qdocconf
 SOURCES += plugin.cpp
diff --git a/src/effects/private/FastGlow.qml b/src/effects/private/FastGlow.qml
index 191c7f5..fb2fa42 100644
--- a/src/effects/private/FastGlow.qml
+++ b/src/effects/private/FastGlow.qml
@@ -64,42 +64,9 @@ Item {
         hideSource: visible
     }
 
-    property string __internalBlurVertexShader: "
-        attribute highp vec4 qt_Vertex;
-        attribute highp vec2 qt_MultiTexCoord0;
-        uniform highp mat4 qt_Matrix;
-        uniform highp float yStep;
-        uniform highp float xStep;
-        varying highp vec2 qt_TexCoord0;
-        varying highp vec2 qt_TexCoord1;
-        varying highp vec2 qt_TexCoord2;
-        varying highp vec2 qt_TexCoord3;
-
-        void main() {
-            qt_TexCoord0 = vec2(qt_MultiTexCoord0.x + xStep, qt_MultiTexCoord0.y + yStep * 0.36);
-            qt_TexCoord1 = vec2(qt_MultiTexCoord0.x + xStep * 0.36, qt_MultiTexCoord0.y - yStep);
-            qt_TexCoord2 = vec2(qt_MultiTexCoord0.x - xStep * 0.36, qt_MultiTexCoord0.y + yStep);
-            qt_TexCoord3 = vec2(qt_MultiTexCoord0.x - xStep, qt_MultiTexCoord0.y - yStep * 0.36);
-            gl_Position = qt_Matrix * qt_Vertex;
-        }
-    "
-
-    property string __internalBlurFragmentShader: "
-        uniform lowp sampler2D source;
-        uniform lowp float qt_Opacity;
-        varying highp vec2 qt_TexCoord0;
-        varying highp vec2 qt_TexCoord1;
-        varying highp vec2 qt_TexCoord2;
-        varying highp vec2 qt_TexCoord3;
-
-        void main() {
-            highp vec4 sourceColor = (texture2D(source, qt_TexCoord0) +
-            texture2D(source, qt_TexCoord1) +
-            texture2D(source, qt_TexCoord2) +
-            texture2D(source, qt_TexCoord3)) * 0.25;
-            gl_FragColor = sourceColor * qt_Opacity;
-        }
-   "
+    property string __internalBlurVertexShader: "qrc:/qt-project.org/imports/QtGraphicalEffects/shaders/fastblur_internal.vert"
+
+    property string __internalBlurFragmentShader: "qrc:/qt-project.org/imports/QtGraphicalEffects/shaders/fastblur_internal.frag"
 
     ShaderEffect {
         id: level0
@@ -359,35 +326,6 @@ Item {
 
         onLodChanged: calculateWeights()
 
-        fragmentShader: "
-            uniform lowp sampler2D source1;
-            uniform lowp sampler2D source2;
-            uniform lowp sampler2D source3;
-            uniform lowp sampler2D source4;
-            uniform lowp sampler2D source5;
-            uniform mediump float weight1;
-            uniform mediump float weight2;
-            uniform mediump float weight3;
-            uniform mediump float weight4;
-            uniform mediump float weight5;
-            uniform highp vec4 color;
-            uniform highp float spread;
-            uniform lowp float qt_Opacity;
-            varying mediump vec2 qt_TexCoord0;
-
-            highp float linearstep(highp float e0, highp float e1, highp float x) {
-                return clamp((x - e0) / (e1 - e0), 0.0, 1.0);
-            }
-
-            void main() {
-                lowp vec4 sourceColor = texture2D(source1, qt_TexCoord0) * weight1;
-                sourceColor += texture2D(source2, qt_TexCoord0) * weight2;
-                sourceColor += texture2D(source3, qt_TexCoord0) * weight3;
-                sourceColor += texture2D(source4, qt_TexCoord0) * weight4;
-                sourceColor += texture2D(source5, qt_TexCoord0) * weight5;
-                sourceColor = mix(vec4(0), color, linearstep(0.0, spread, sourceColor.a));
-                gl_FragColor = sourceColor * qt_Opacity;
-            }
-        "
+        fragmentShader: "qrc:/qt-project.org/imports/QtGraphicalEffects/shaders/fastglow.frag"
     }
 }
diff --git a/src/effects/private/FastInnerShadow.qml b/src/effects/private/FastInnerShadow.qml
index 82690c5..be21d8e 100644
--- a/src/effects/private/FastInnerShadow.qml
+++ b/src/effects/private/FastInnerShadow.qml
@@ -65,42 +65,9 @@ Item {
         hideSource: visible
     }
 
-    property string __internalBlurVertexShader: "
-        attribute highp vec4 qt_Vertex;
-        attribute highp vec2 qt_MultiTexCoord0;
-        uniform highp mat4 qt_Matrix;
-        uniform highp float yStep;
-        uniform highp float xStep;
-        varying highp vec2 qt_TexCoord0;
-        varying highp vec2 qt_TexCoord1;
-        varying highp vec2 qt_TexCoord2;
-        varying highp vec2 qt_TexCoord3;
-
-        void main() {
-            qt_TexCoord0 = vec2(qt_MultiTexCoord0.x + xStep, qt_MultiTexCoord0.y + yStep * 0.36);
-            qt_TexCoord1 = vec2(qt_MultiTexCoord0.x + xStep * 0.36, qt_MultiTexCoord0.y - yStep);
-            qt_TexCoord2 = vec2(qt_MultiTexCoord0.x - xStep * 0.36, qt_MultiTexCoord0.y + yStep);
-            qt_TexCoord3 = vec2(qt_MultiTexCoord0.x - xStep, qt_MultiTexCoord0.y - yStep * 0.36);
-            gl_Position = qt_Matrix * qt_Vertex;
-        }
-    "
-
-    property string __internalBlurFragmentShader: "
-        uniform lowp sampler2D source;
-        uniform lowp float qt_Opacity;
-        varying highp vec2 qt_TexCoord0;
-        varying highp vec2 qt_TexCoord1;
-        varying highp vec2 qt_TexCoord2;
-        varying highp vec2 qt_TexCoord3;
-
-        void main() {
-            highp vec4 sourceColor = (texture2D(source, qt_TexCoord0) +
-            texture2D(source, qt_TexCoord1) +
-            texture2D(source, qt_TexCoord2) +
-            texture2D(source, qt_TexCoord3)) * 0.25;
-            gl_FragColor = sourceColor * qt_Opacity;
-        }
-   "
+    property string __internalBlurVertexShader: "qrc:/qt-project.org/imports/QtGraphicalEffects/shaders/fastblur_internal.vert"
+
+    property string __internalBlurFragmentShader: "qrc:/qt-project.org/imports/QtGraphicalEffects/shaders/fastblur_internal.frag"
 
     ShaderEffect {
         id: level0
@@ -112,21 +79,7 @@ Item {
         anchors.fill: parent
         visible: false
         smooth: true
-        fragmentShader: "
-            varying highp vec2 qt_TexCoord0;
-            uniform lowp float qt_Opacity;
-            uniform highp sampler2D source;
-            uniform lowp vec4 color;
-            uniform highp float horizontalOffset;
-            uniform highp float verticalOffset;
-
-            void main(void) {
-                highp vec2 pos = qt_TexCoord0 - vec2(horizontalOffset, verticalOffset);
-                lowp float ea = step(0.0, pos.x) * step(0.0, pos.y) * step(pos.x, 1.0) * step(pos.y, 1.0);
-                lowp float eb = 1.0 - ea;
-                gl_FragColor = (eb * color + ea * color * (1.0 - texture2D(source, pos).a)) * qt_Opacity;
-            }
-        "
+        fragmentShader: "qrc:/qt-project.org/imports/QtGraphicalEffects/shaders/fastinnershadow_level0.frag"
     }
 
     ShaderEffectSource {
@@ -377,37 +330,6 @@ Item {
 
         onLodChanged: calculateWeights()
 
-        fragmentShader: "
-            uniform lowp sampler2D original;
-            uniform lowp sampler2D source1;
-            uniform lowp sampler2D source2;
-            uniform lowp sampler2D source3;
-            uniform lowp sampler2D source4;
-            uniform lowp sampler2D source5;
-            uniform mediump float weight1;
-            uniform mediump float weight2;
-            uniform mediump float weight3;
-            uniform mediump float weight4;
-            uniform mediump float weight5;
-            uniform highp vec4 color;
-            uniform highp float spread;
-            uniform lowp float qt_Opacity;
-            varying mediump vec2 qt_TexCoord0;
-
-            highp float linearstep(highp float e0, highp float e1, highp float x) {
-                return clamp((x - e0) / (e1 - e0), 0.0, 1.0);
-            }
-
-            void main() {
-                lowp vec4 shadowColor = texture2D(source1, qt_TexCoord0) * weight1;
-                shadowColor += texture2D(source2, qt_TexCoord0) * weight2;
-                shadowColor += texture2D(source3, qt_TexCoord0) * weight3;
-                shadowColor += texture2D(source4, qt_TexCoord0) * weight4;
-                shadowColor += texture2D(source5, qt_TexCoord0) * weight5;
-                lowp vec4 originalColor = texture2D(original, qt_TexCoord0);
-                shadowColor.rgb = mix(originalColor.rgb, color.rgb * originalColor.a, linearstep(0.0, spread, shadowColor.a));
-                gl_FragColor = vec4(shadowColor.rgb, originalColor.a) * originalColor.a * qt_Opacity;
-            }
-        "
+        fragmentShader: "qrc:/qt-project.org/imports/QtGraphicalEffects/shaders/fastinnershadow.frag"
     }
 }
diff --git a/src/effects/private/FastMaskedBlur.qml b/src/effects/private/FastMaskedBlur.qml
index cfdace4..ef26704 100644
--- a/src/effects/private/FastMaskedBlur.qml
+++ b/src/effects/private/FastMaskedBlur.qml
@@ -68,42 +68,9 @@ Item {
         smooth: rootItem.blur > 0
     }
 
-    property string __internalBlurVertexShader: "
-        attribute highp vec4 qt_Vertex;
-        attribute highp vec2 qt_MultiTexCoord0;
-        uniform highp mat4 qt_Matrix;
-        uniform highp float yStep;
-        uniform highp float xStep;
-        varying highp vec2 qt_TexCoord0;
-        varying highp vec2 qt_TexCoord1;
-        varying highp vec2 qt_TexCoord2;
-        varying highp vec2 qt_TexCoord3;
+    property string __internalBlurVertexShader: "qrc:/qt-project.org/imports/QtGraphicalEffects/shaders/fastblur_internal.vert"
 
-        void main() {
-            qt_TexCoord0 = vec2(qt_MultiTexCoord0.x + xStep, qt_MultiTexCoord0.y + yStep * 0.36);
-            qt_TexCoord1 = vec2(qt_MultiTexCoord0.x + xStep * 0.36, qt_MultiTexCoord0.y - yStep);
-            qt_TexCoord2 = vec2(qt_MultiTexCoord0.x - xStep * 0.36, qt_MultiTexCoord0.y + yStep);
-            qt_TexCoord3 = vec2(qt_MultiTexCoord0.x - xStep, qt_MultiTexCoord0.y - yStep * 0.36);
-            gl_Position = qt_Matrix * qt_Vertex;
-        }
-    "
-
-    property string __internalBlurFragmentShader: "
-        uniform lowp sampler2D source;
-        uniform lowp float qt_Opacity;
-        varying highp vec2 qt_TexCoord0;
-        varying highp vec2 qt_TexCoord1;
-        varying highp vec2 qt_TexCoord2;
-        varying highp vec2 qt_TexCoord3;
-
-        void main() {
-            highp vec4 sourceColor = (texture2D(source, qt_TexCoord0) +
-            texture2D(source, qt_TexCoord1) +
-            texture2D(source, qt_TexCoord2) +
-            texture2D(source, qt_TexCoord3)) * 0.25;
-            gl_FragColor = sourceColor * qt_Opacity;
-        }
-   "
+    property string __internalBlurFragmentShader: "qrc:/qt-project.org/imports/QtGraphicalEffects/shaders/fastblur_internal.frag"
 
     ShaderEffect {
         id: mask0
@@ -275,58 +242,6 @@ Item {
         width: transparentBorder ? parent.width + 128 : parent.width
         height: transparentBorder ? parent.height + 128 : parent.height
 
-        fragmentShader: "
-            uniform lowp sampler2D mask;
-            uniform lowp sampler2D source1;
-            uniform lowp sampler2D source2;
-            uniform lowp sampler2D source3;
-            uniform lowp sampler2D source4;
-            uniform lowp sampler2D source5;
-            uniform lowp sampler2D source6;
-            uniform lowp float lod;
-            uniform lowp float qt_Opacity;
-            varying mediump vec2 qt_TexCoord0;
-
-            mediump float weight(mediump float v) {
-                if (v <= 0.0)
-                    return 1.0;
-
-                if (v >= 0.5)
-                    return 0.0;
-
-                return 1.0 - v * 2.0;
-            }
-
-            void main() {
-
-                lowp vec4 maskColor = texture2D(mask, qt_TexCoord0);
-                mediump float l = lod * maskColor.a;
-
-                mediump float w1 = weight(abs(l - 0.100));
-                mediump float w2 = weight(abs(l - 0.300));
-                mediump float w3 = weight(abs(l - 0.500));
-                mediump float w4 = weight(abs(l - 0.700));
-                mediump float w5 = weight(abs(l - 0.900));
-                mediump float w6 = weight(abs(l - 1.100));
-
-                mediump float sum = w1 + w2 + w3 + w4 + w5 + w6;
-                mediump float weight1 = w1 / sum;
-                mediump float weight2 = w2 / sum;
-                mediump float weight3 = w3 / sum;
-                mediump float weight4 = w4 / sum;
-                mediump float weight5 = w5 / sum;
-                mediump float weight6 = w6 / sum;
-
-                lowp vec4 sourceColor = texture2D(source1, qt_TexCoord0) * weight1;
-                sourceColor += texture2D(source2, qt_TexCoord0) * weight2;
-                sourceColor += texture2D(source3, qt_TexCoord0) * weight3;
-                sourceColor += texture2D(source4, qt_TexCoord0) * weight4;
-                sourceColor += texture2D(source5, qt_TexCoord0) * weight5;
-                sourceColor += texture2D(source6, qt_TexCoord0) * weight6;
-
-                gl_FragColor = sourceColor * qt_Opacity;
-
-            }
-        "
+        fragmentShader: "qrc:/qt-project.org/imports/QtGraphicalEffects/shaders/fastmaskedblur.frag"
     }
 }
diff --git a/src/effects/private/GaussianDirectionalBlur.qml b/src/effects/private/GaussianDirectionalBlur.qml
index 0a62b80..af1ca70 100644
--- a/src/effects/private/GaussianDirectionalBlur.qml
+++ b/src/effects/private/GaussianDirectionalBlur.qml
@@ -37,7 +37,7 @@
 **
 ****************************************************************************/
 
-import QtQuick 2.0
+import QtQuick 2.8
 import QtGraphicalEffects.private 1.0
 
 Item {
@@ -180,7 +180,10 @@ Item {
             "gl_FragColor += texture2D(source, texCoord) * factor_30_31.y; texCoord += shift;"
         ]
 
-            var shader = fragmentShaderBegin
+            var shader = ""
+            if (GraphicsInfo.profile == GraphicsInfo.OpenGLCoreProfile)
+                shader += "#version 150 core\n#define varying in\n#define gl_FragColor fragColor\n#define texture2D texture\nout vec4 fragColor;\n"
+            shader += fragmentShaderBegin
             var samples = maxRadius * 2
             if (samples > 32) {
                 console.log("DirectionalGaussianBlur.qml WARNING: Maximum of blur radius (16) exceeded!")
diff --git a/src/effects/private/GaussianInnerShadow.qml b/src/effects/private/GaussianInnerShadow.qml
index f3becae..7207963 100644
--- a/src/effects/private/GaussianInnerShadow.qml
+++ b/src/effects/private/GaussianInnerShadow.qml
@@ -76,21 +76,7 @@ Item {
         property real verticalOffset: rootItem.verticalOffset / rootItem.height
 
         visible: false
-        fragmentShader: "
-            uniform highp sampler2D original;
-            uniform lowp float qt_Opacity;
-            uniform lowp vec4 color;
-            uniform highp float horizontalOffset;
-            uniform highp float verticalOffset;
-            varying highp vec2 qt_TexCoord0;
-
-            void main(void) {
-                highp vec2 pos = qt_TexCoord0 - vec2(horizontalOffset, verticalOffset);
-                lowp float ea = step(0.0, pos.x) * step(0.0, pos.y) * step(pos.x, 1.0) * step(pos.y, 1.0);
-                lowp float eb = 1.0 - ea;
-                gl_FragColor = eb * color + ea * color * (1.0 - texture2D(original, pos).a) * qt_Opacity;
-            }
-        "
+        fragmentShader: "qrc:/qt-project.org/imports/QtGraphicalEffects/shaders/gaussianinnershadow_shadow.frag"
     }
 
     GaussianDirectionalBlur {
@@ -132,24 +118,6 @@ Item {
         property real spread: 1.0 - (rootItem.spread * 0.98)
         property color color: rootItem.color
 
-        fragmentShader: "
-            uniform highp sampler2D original;
-            uniform highp sampler2D shadow;
-            uniform lowp float qt_Opacity;
-            uniform highp float spread;
-            uniform lowp vec4 color;
-            varying highp vec2 qt_TexCoord0;
-
-            highp float linearstep(highp float e0, highp float e1, highp float x) {
-                return clamp((x - e0) / (e1 - e0), 0.0, 1.0);
-            }
-
-            void main(void) {
-                lowp vec4 originalColor = texture2D(original, qt_TexCoord0);
-                lowp vec4 shadowColor = texture2D(shadow, qt_TexCoord0);
-                shadowColor.rgb = mix(originalColor.rgb, color.rgb * originalColor.a, linearstep(0.0, spread, shadowColor.a));
-                gl_FragColor = vec4(shadowColor.rgb, originalColor.a) * originalColor.a * qt_Opacity;
-            }
-        "
+        fragmentShader: "qrc:/qt-project.org/imports/QtGraphicalEffects/shaders/gaussianinnershadow.frag"
     }
 }
